Index: applications/editors/josm/plugins/tracer2/build.xml
===================================================================
--- applications/editors/josm/plugins/tracer2/build.xml	(revision 32309)
+++ applications/editors/josm/plugins/tracer2/build.xml	(revision 32474)
@@ -5,10 +5,7 @@
     <property name="commit.message" value="see #josm11090"/>
     <!-- enter the *lowest* JOSM version this plugin is currently compatible with -->
-    <property name="plugin.main.version" value="7001"/>
+    <property name="plugin.main.version" value="10353"/>
 
     <!-- Configure these properties (replace "..." accordingly).
-
-
-
          See https://josm.openstreetmap.de/wiki/DevelopersGuide/DevelopingPlugins
     -->
Index: applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/ConnectWays.java
===================================================================
--- applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/ConnectWays.java	(revision 32309)
+++ applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/ConnectWays.java	(revision 32474)
@@ -75,5 +75,5 @@
     	BBox bbox = new BBox(way);
     	bbox.addPrimitive(way,s_dMinDistance);
-        s_oWays = Main.main.getCurrentDataSet().searchWays(bbox);
+        s_oWays = Main.getLayerManager().getEditDataSet().searchWays(bbox);
     }
     
@@ -87,5 +87,5 @@
     	BBox bbox = new BBox(way);
     	bbox.addPrimitive(way,s_dMinDistance);
-    	s_oNodes = Main.main.getCurrentDataSet().searchNodes(bbox);
+    	s_oNodes = Main.getLayerManager().getEditDataSet().searchNodes(bbox);
     }
     
Index: applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TagValues.java
===================================================================
--- applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TagValues.java	(revision 32309)
+++ applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TagValues.java	(revision 32474)
@@ -54,5 +54,5 @@
     	// get values
         List<String> tagValues = new ArrayList<>();
-        List<AutoCompletionListItem> values = Main.main.getCurrentDataSet().getAutoCompletionManager().getValues(m_strTag);
+        List<AutoCompletionListItem> values = Main.getLayerManager().getEditDataSet().getAutoCompletionManager().getValues(m_strTag);
         for ( AutoCompletionListItem i : values ) {
         	tagValues.add(i.getValue());
Index: applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TracerAction.java
===================================================================
--- applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TracerAction.java	(revision 32309)
+++ applications/editors/josm/plugins/tracer2/src/org/openstreetmap/josm/plugins/tracer2/TracerAction.java	(revision 32474)
@@ -27,7 +27,7 @@
 import java.awt.event.InputEvent;
 import java.awt.event.KeyEvent;
+import java.awt.event.KeyListener;
 import java.awt.event.MouseEvent;
 import java.awt.event.MouseListener;
-import java.awt.event.KeyListener;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -38,8 +38,6 @@
 import javax.swing.JOptionPane;
 
-import org.xml.sax.SAXException;
 import org.openstreetmap.josm.Main;
 import org.openstreetmap.josm.actions.mapmode.MapMode;
-import org.openstreetmap.josm.command.AddCommand;
 import org.openstreetmap.josm.command.ChangePropertyCommand;
 import org.openstreetmap.josm.command.Command;
@@ -47,16 +45,17 @@
 import org.openstreetmap.josm.data.coor.LatLon;
 import org.openstreetmap.josm.data.osm.Node;
+import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.data.osm.Way;
+import org.openstreetmap.josm.gui.MapFrame;
 import org.openstreetmap.josm.gui.PleaseWaitRunnable;
 import org.openstreetmap.josm.gui.progress.ProgressMonitor;
-import org.openstreetmap.josm.gui.MapFrame;
 import org.openstreetmap.josm.plugins.tracer2.preferences.ServerParam;
 import org.openstreetmap.josm.plugins.tracer2.preferences.ServerParamList;
 import org.openstreetmap.josm.plugins.tracer2.preferences.ServerParamSelectDialog;
+import org.openstreetmap.josm.plugins.tracer2.server.GetTrace;
 import org.openstreetmap.josm.plugins.tracer2.server.GetVersion;
-import org.openstreetmap.josm.plugins.tracer2.server.GetTrace;
 import org.openstreetmap.josm.tools.ImageProvider;
 import org.openstreetmap.josm.tools.Shortcut;
-import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.xml.sax.SAXException;
 
 class TracerAction extends MapMode implements MouseListener, KeyListener {
@@ -82,5 +81,5 @@
     	//System.out.println("keyPressed: key:" + e.getKeyChar() + " code" + e.getKeyCode() + " Loc" + e.getKeyLocation()+ " ID" + KeyEvent.getKeyText(e.getKeyCode()));
         
-    	Collection<OsmPrimitive> selection = getCurrentDataSet().getSelected();
+    	Collection<OsmPrimitive> selection = getLayerManager().getEditDataSet().getSelected();
     	List<Command> commands = new ArrayList<>();
     	
@@ -340,7 +339,7 @@
             	
                 if (m_bShift) {
-                    Main.main.getCurrentDataSet().addSelected(ConnectWays.s_oWay);
+                    getLayerManager().getEditDataSet().addSelected(ConnectWays.s_oWay);
                 } else {
-                    Main.main.getCurrentDataSet().setSelected(ConnectWays.s_oWay);
+                    getLayerManager().getEditDataSet().setSelected(ConnectWays.s_oWay);
                 }
             } else {