Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/Checker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/Checker.java	(revision 32585)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/Checker.java	(revision 32587)
@@ -57,18 +57,18 @@
 
 				if (rm.getMember().hasTag("public_transport", "stop_position")) {
-					if (!rm.hasRole("stop") && !rm.hasRole("stop_entry_only") && !rm.hasRole("stop_exit_only")) {
-						RelationMember newMember = new RelationMember("stop", rm.getMember());
-						resultList.add(newMember);
-					} else {
+//					if (!rm.hasRole("stop") && !rm.hasRole("stop_entry_only") && !rm.hasRole("stop_exit_only")) {
+//						RelationMember newMember = new RelationMember("stop", rm.getMember());
+//						resultList.add(newMember);
+//					} else {
 						resultList.add(rm);
-					}
+//					}
 				} else { // if platform
-					if (!rm.hasRole("platform") && !rm.hasRole("platform_entry_only")
-							&& !rm.hasRole("platform_exit_only")) {
-						RelationMember newMember = new RelationMember("platform", rm.getMember());
-						resultList.add(newMember);
-					} else {
+//					if (!rm.hasRole("platform") && !rm.hasRole("platform_entry_only")
+//							&& !rm.hasRole("platform_exit_only")) {
+//						RelationMember newMember = new RelationMember("platform", rm.getMember());
+//						resultList.add(newMember);
+//					} else {
 						resultList.add(rm);
-					}
+//					}
 				}
 
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/WayChecker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/WayChecker.java	(revision 32585)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/WayChecker.java	(revision 32587)
@@ -7,4 +7,5 @@
 import java.util.List;
 
+import javax.swing.JOptionPane;
 import javax.swing.SwingUtilities;
 
@@ -24,6 +25,6 @@
 import org.openstreetmap.josm.data.validation.Test;
 import org.openstreetmap.josm.data.validation.TestError;
-import org.openstreetmap.josm.gui.dialogs.relation.GenericRelationEditor;
 import org.openstreetmap.josm.gui.dialogs.relation.RelationDialogManager;
+import org.openstreetmap.josm.gui.dialogs.relation.RelationEditor;
 import org.openstreetmap.josm.gui.dialogs.relation.sort.WayConnectionType;
 import org.openstreetmap.josm.gui.dialogs.relation.sort.WayConnectionTypeCalculator;
@@ -298,7 +299,8 @@
 		SelectCommand command2 = new SelectCommand(primitivesToZoom);
 		commands.add(command2);
-
-		List<RelationMember> sortedRelationMembers = listStopMembers(originalRelation);
-		sortedRelationMembers.addAll(listNotStopMembers(originalRelation));
+//
+//		List<RelationMember> sortedRelationMembers = listStopMembers(originalRelation);
+//		sortedRelationMembers.addAll(listNotStopMembers(originalRelation));
+//		originalRelation.setMembers(sortedRelationMembers);
 		
 		List<OsmDataLayer> listOfLayers = Main.getLayerManager().getLayersOfType(OsmDataLayer.class);
@@ -307,6 +309,7 @@
 
 				final OsmDataLayer layerParameter = osmDataLayer;
-				final Relation relationParameter = new Relation(originalRelation);
-				relationParameter.setMembers(sortedRelationMembers);
+//				final Relation relationParameter = new Relation(originalRelation);
+//				relationParameter.setMembers(sortedRelationMembers);
+				final Relation relationParameter = originalRelation;
 				final Collection<OsmPrimitive> zoomParameter = primitivesToZoom;
 
@@ -339,6 +342,5 @@
 
 		AutoScaleAction.zoomTo(primitives);
-		GenericRelationEditor editor = new GenericRelationEditor(layer, r, r.getMembersFor(primitives));
-		RelationDialogManager.getRelationDialogManager().register(layer, r, editor);
+		RelationEditor editor = RelationEditor.getEditor(layer, r, r.getMembersFor(primitives));
 		editor.setVisible(true);
 		