Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/utils/StopUtils.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/utils/StopUtils.java	(revision 32784)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/utils/StopUtils.java	(revision 32791)
@@ -1,20 +1,6 @@
 package org.openstreetmap.josm.plugins.pt_assistant.utils;
 
-import static org.openstreetmap.josm.tools.I18n.tr;
-
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.List;
-
-import org.openstreetmap.josm.data.osm.Node;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
-import org.openstreetmap.josm.data.osm.OsmPrimitiveType;
-import org.openstreetmap.josm.data.osm.OsmUtils;
 import org.openstreetmap.josm.data.osm.Relation;
-import org.openstreetmap.josm.data.osm.RelationMember;
-import org.openstreetmap.josm.data.osm.Way;
-import org.openstreetmap.josm.data.validation.TestError;
-import org.openstreetmap.josm.plugins.pt_assistant.data.PTRouteDataManager;
-import org.openstreetmap.josm.plugins.pt_assistant.validation.PTAssistantValidatorTest;
 
 /**
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java	(revision 32784)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java	(revision 32791)
@@ -5,10 +5,6 @@
 import java.lang.reflect.InvocationTargetException;
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
-import java.util.Set;
-import java.util.LinkedList;
-import java.util.Collection;
-import java.util.HashMap;
-import java.util.Collections;
 
 import javax.swing.JOptionPane;
@@ -22,7 +18,7 @@
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.data.osm.OsmPrimitiveType;
-import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.data.osm.Relation;
 import org.openstreetmap.josm.data.osm.RelationMember;
+import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.data.validation.Severity;
 import org.openstreetmap.josm.data.validation.Test;
@@ -89,5 +85,5 @@
 		}
 	}
-	
+
 	/**
 	 * Checks if the given stop_position node belongs to any stop_area relation
@@ -96,17 +92,20 @@
 	 */
 	protected void performNodePartOfStopAreaTest() {
-				
+
 		if (!StopUtils.verifyIfMemberOfStopArea(node)) {
-		
+
 			List<OsmPrimitive> primitives = new ArrayList<>(1);
 			primitives.add(node);
-			TestError e = new TestError(this.test, Severity.WARNING, tr("PT: Stop position or platform is not part of a stop area relation"),
+			TestError e = new TestError(this.test, Severity.WARNING,
+					tr("PT: Stop position or platform is not part of a stop area relation"),
 					PTAssistantValidatorTest.ERROR_CODE_NODE_PART_OF_STOP_AREA, primitives);
 			errors.add(e);
 		}
 	}
-	
-	/**
-	 * Checks if the given stop_position belongs to the same route relations as it's related platform(s).	 * 
+
+	/**
+	 * Checks if the given stop_position belongs to the same route relations as
+	 * its related platform(s). *
+	 * 
 	 * @param n
 	 */
@@ -123,13 +122,17 @@
 				stopPositionRelationIds.put(referrer.getId(), referrer.getId());
 			}
-			
+
 			// Create list of relations the related platform(s) belongs to
 			else if (referrer.get("public_transport") == "stop_area") {
 				for (RelationMember stopAreaMember : referrer.getMembers()) {
-					Node stopAreaMemberFoo = stopAreaMember.getNode();
-					if (stopAreaMemberFoo.get("public_transport") == "platform") {
-						for (Relation stopAreaMemberReferrer : OsmPrimitive.getFilteredList(stopAreaMemberFoo.getReferrers(), Relation.class)) {
-							if (stopAreaMemberReferrer.get("type") == "route") {
-								platformRelationIds.put(stopAreaMemberReferrer.getId(), stopAreaMemberReferrer.getId());
+					if (stopAreaMember.isNode()) {
+						Node stopAreaMemberFoo = stopAreaMember.getNode();
+						if (stopAreaMemberFoo.get("public_transport") == "platform") {
+							for (Relation stopAreaMemberReferrer : OsmPrimitive
+									.getFilteredList(stopAreaMemberFoo.getReferrers(), Relation.class)) {
+								if (stopAreaMemberReferrer.get("type") == "route") {
+									platformRelationIds.put(stopAreaMemberReferrer.getId(),
+											stopAreaMemberReferrer.getId());
+								}
 							}
 						}
@@ -143,12 +146,12 @@
 			return;
 		}
-		
+
 		List<OsmPrimitive> primitives = new ArrayList<>(1);
 		primitives.add(node);
-		TestError e = new TestError(this.test, Severity.WARNING, tr("PT: Stop position and it's related platform(s) have different route relations"),
+		TestError e = new TestError(this.test, Severity.WARNING,
+				tr("PT: Stop position and its related platform(s) have different route relations"),
 				PTAssistantValidatorTest.ERROR_CODE_STOP_POSITION_COMPARE_RELATIONS, primitives);
 		errors.add(e);
 	}
-	
 
 	/**
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java	(revision 32784)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java	(revision 32791)
@@ -5,8 +5,5 @@
 import java.lang.reflect.InvocationTargetException;
 import java.util.ArrayList;
-import java.util.Collection;
-import java.util.LinkedList;
 import java.util.List;
-import java.util.Set;
 
 import javax.swing.JOptionPane;
@@ -17,5 +14,4 @@
 import org.openstreetmap.josm.data.osm.DataSet;
 import org.openstreetmap.josm.data.osm.Node;
-import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.data.osm.Relation;
 import org.openstreetmap.josm.data.osm.Way;
@@ -33,6 +29,6 @@
 import org.openstreetmap.josm.plugins.pt_assistant.gui.ProceedDialog;
 import org.openstreetmap.josm.plugins.pt_assistant.utils.RouteUtils;
+import org.openstreetmap.josm.plugins.pt_assistant.utils.StopToWayAssigner;
 import org.openstreetmap.josm.plugins.pt_assistant.utils.StopUtils;
-import org.openstreetmap.josm.plugins.pt_assistant.utils.StopToWayAssigner;
 
 public class PTAssistantValidatorTest extends Test {
@@ -111,4 +107,6 @@
 	public void visit(Relation r) {
 		
+		System.out.println("starting: visit relation id=" + r.getId() + ", ref: " + r.get("ref") + ", " + r.getMembersCount() + " members");
+		
 		// Do some testing on stop area relations
 		if (StopUtils.isStopArea(r)) {
@@ -133,4 +131,5 @@
 
 		if (!RouteUtils.isTwoDirectionRoute(r)) {
+			System.out.println("return: not two-direction route");
 			return;
 		}
@@ -142,4 +141,5 @@
 			boolean downloadSuccessful = this.downloadIncompleteMembers();
 			if (!downloadSuccessful) {
+				System.out.println("return: download not successful");
 				return;
 			}
@@ -147,4 +147,5 @@
 
 		if (r.hasIncompleteMembers()) {
+			System.out.println("return: has incomplete members");
 			return;
 		}
@@ -164,4 +165,6 @@
 			this.proceedAfterWayCheckerErrors(r);
 		}
+
+		System.out.println("ending: visit relation id=" + r.getId() + ", ref: " + r.get("ref") + ", " + r.getMembersCount() + " members");
 
 	}
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java	(revision 32784)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java	(revision 32791)
@@ -4,17 +4,9 @@
 
 import java.util.ArrayList;
-import java.util.Collection;
 import java.util.List;
 import java.util.Set;
-import java.util.HashMap;
 
-
-import org.openstreetmap.josm.command.ChangeCommand;
-import org.openstreetmap.josm.command.Command;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
-import org.openstreetmap.josm.data.osm.OsmPrimitiveType;
 import org.openstreetmap.josm.data.osm.Relation;
-import org.openstreetmap.josm.data.osm.RelationMember;
-import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.data.validation.Severity;
 import org.openstreetmap.josm.data.validation.Test;