Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java	(revision 32819)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/NodeChecker.java	(revision 32822)
@@ -5,5 +5,4 @@
 import java.lang.reflect.InvocationTargetException;
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
 
@@ -99,63 +98,9 @@
 			TestError e = new TestError(this.test, Severity.WARNING,
 					tr("PT: Stop position or platform is not part of a stop area relation"),
-					PTAssistantValidatorTest.ERROR_CODE_NODE_PART_OF_STOP_AREA, primitives);
+					PTAssistantValidatorTest.ERROR_CODE_NOT_PART_OF_STOP_AREA, primitives);
 			errors.add(e);
 		}
 	}
 
-	/**
-	 * Checks if the given stop_position belongs to the same route relations as
-	 * its related platform(s). *
-	 * 
-	 * @param n
-	 */
-	protected void performStopPositionComparePlatformRelations() {
-
-		HashMap<Long, Long> stopPositionRelationIds = new HashMap<>();
-		HashMap<Long, Long> platformRelationIds = new HashMap<>();
-
-		// Loop through all referrer relations
-		for (Relation referrer : OsmPrimitive.getFilteredList(node.getReferrers(), Relation.class)) {
-
-			// Create list of relations the stop position belongs to
-			if (referrer.get("type") == "route") {
-				stopPositionRelationIds.put(referrer.getId(), referrer.getId());
-			}
-
-			// Create list of relations the related platform(s) belongs to
-			else if (referrer.get("public_transport") == "stop_area") {
-				for (RelationMember stopAreaMember : referrer.getMembers()) {
-					OsmPrimitive stopAreaMemberFoo = stopAreaMember.getMember();
-					if (stopAreaMemberFoo.get("public_transport") == "platform") {
-						for (Relation stopAreaMemberReferrer : OsmPrimitive
-								.getFilteredList(stopAreaMemberFoo.getReferrers(), Relation.class)) {
-							if (stopAreaMemberReferrer.get("type") == "route") {
-								platformRelationIds.put(stopAreaMemberReferrer.getId(), stopAreaMemberReferrer.getId());
-							}
-						}
-					}
-				}
-			}
-		}
-
-		// Check if the stop_position has no referrers at all. If it has no
-		// referrers, then no error should be reported (changed on 11.08.2016 by
-		// darya):
-		if (stopPositionRelationIds.isEmpty()) {
-			return;
-		}
-
-		// Check if route relation lists are identical
-		if (stopPositionRelationIds.equals(platformRelationIds)) {
-			return;
-		}
-
-		List<OsmPrimitive> primitives = new ArrayList<>(1);
-		primitives.add(node);
-		TestError e = new TestError(this.test, Severity.WARNING,
-				tr("PT: Stop position and its related platform(s) have different route relations"),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_POSITION_COMPARE_RELATIONS, primitives);
-		errors.add(e);
-	}
 
 	/**
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java	(revision 32819)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/PTAssistantValidatorTest.java	(revision 32822)
@@ -46,14 +46,9 @@
 	public static final int ERROR_CODE_STOP_NOT_SERVED = 3753;
 	public static final int ERROR_CODE_STOP_BY_STOP = 3754;
-	public static final int ERROR_CODE_STOP_POSITION_COMPARE_RELATIONS = 3755;
-	public static final int ERROR_CODE_NODE_PART_OF_STOP_AREA = 3761;
-	public static final int ERROR_CODE_STOP_AREA_MEMBERS_EXCESS = 3762;
-	public static final int ERROR_CODE_STOP_AREA_STOP_POSITION = 3763;
-	public static final int ERROR_CODE_STOP_AREA_PLATFORM = 3764;
-	public static final int ERROR_CODE_STOP_AREA_NO_STOPS = 3765;
-	public static final int ERROR_CODE_STOP_AREA_MANY_STOPS = 3765;
-	public static final int ERROR_CODE_STOP_AREA_NO_PLATFORM = 3766;
-	public static final int ERROR_CODE_STOP_AREA_MANY_PLATFORMS = 3767;
-	public static final int ERROR_CODE_STOP_AREA_MEMBERS_RELATIONS = 3768;
+	public static final int ERROR_CODE_NOT_PART_OF_STOP_AREA = 3761;
+	public static final int ERROR_CODE_STOP_AREA_NO_STOPS = 3762;
+	public static final int ERROR_CODE_STOP_AREA_NO_PLATFORM = 3763;
+	public static final int ERROR_CODE_STOP_AREA_COMPARE_RELATIONS = 3764;
+
 
 
@@ -86,7 +81,5 @@
 			// check if stop positions are in any stop_area relation:
 			nodeChecker.performNodePartOfStopAreaTest();
-			
-			// Check if stop positions belong the same route relation as related platform(s)
-			nodeChecker.performStopPositionComparePlatformRelations();
+
 		}
 
@@ -115,13 +108,10 @@
 			// Check if stop area relation has one stop position. 
 			stopChecker.performStopAreaStopPositionTest();
-			
-			// Check if stop area relation has more than one stop position. 
-			stopChecker.performStopAreaMultiStopPositionTest();
 
 			// Check if stop area relation has one platform. 
 			stopChecker.performStopAreaPlatformTest();
-
-			// Check if stop area relation has more than one platform. 
-			stopChecker.performStopAreaMultiPlatformTest();
+			
+			// Check if stop position(s) belong the same route relation as related platform(s)
+			stopChecker.performStopAreaRelationsTest();
 
 			// Attach thrown errors
Index: applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java	(revision 32819)
+++ applications/editors/josm/plugins/pt_assistant/src/org/openstreetmap/josm/plugins/pt_assistant/validation/StopChecker.java	(revision 32822)
@@ -6,7 +6,9 @@
 import java.util.List;
 import java.util.Set;
+import java.util.HashMap;
 
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.data.osm.Relation;
+import org.openstreetmap.josm.data.osm.RelationMember;
 import org.openstreetmap.josm.data.validation.Severity;
 import org.openstreetmap.josm.data.validation.Test;
@@ -50,31 +52,4 @@
 	}
 
-	/**
-	 * Checks if the given stop area relation has more than one stop position.
-	 */
-	protected void performStopAreaMultiStopPositionTest() {
-		
-		// Count members tagged as stop position.
-		int countStopPosition = 0;
-		for (OsmPrimitive member : members) {
-			if (StopUtils.verifyStopAreaStopPosition(member)) {
-				countStopPosition++;
-
-			}
-		}
-
-		// No errors if there are more than one stop position.
-		if (countStopPosition <= 1) {
-			return;
-		}
-		
-		// Throw error message
-		List<OsmPrimitive> primitives = new ArrayList<>(1);
-		primitives.add(relation);
-		TestError e = new TestError(this.test, Severity.WARNING, tr("PT: Stop area relation has several stop positions"),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_MANY_STOPS, primitives);
-		errors.add(e);
-		
-	}
 	
 	/**
@@ -101,29 +76,60 @@
 
 	/**
-	 * Checks if the given stop area relation has more than one platform. 
+	 * Checks if the stop_position(s) of an stop area belong to the same route relations as
+	 * its related platform(s). 
+	 * 
+	 * @param n
 	 */
-	protected void performStopAreaMultiPlatformTest() {
-		
-		// Count members tagged as platformn.
-		int countPlatform = 0;
+	protected void performStopAreaRelationsTest() {
+
+		HashMap<Long, Long> stopPositionRelationIds = new HashMap<>();
+		HashMap<Long, Long> platformRelationIds = new HashMap<>();
+
+
+		// Loop through all members
 		for (OsmPrimitive member : members) {
-			if (StopUtils.verifyStopAreaPlatform(member)) {
-				countPlatform++;
+			
+			// For stop positions...
+			if (StopUtils.verifyStopAreaStopPosition(member)) {
+				
+				// Create a list of assigned route relations
+				for (Relation referrer : OsmPrimitive.getFilteredList(member.getReferrers(), Relation.class)) {
+					if (referrer.get("type") == "route") {
+						stopPositionRelationIds.put(referrer.getId(), referrer.getId());
+					}
+				}
+			}
+			
+			// For platforms...
+			else if (StopUtils.verifyStopAreaPlatform(member)) {
 
-			}
+				// Create a list of assigned route relations
+				for (Relation referrer : OsmPrimitive.getFilteredList(member.getReferrers(), Relation.class)) {
+					if (referrer.get("type") == "route") {
+						platformRelationIds.put(referrer.getId(), referrer.getId());
+					}
+				}
+			}	
 		}
 		
-		// No errors if there are more than one platformnn.
-		if (countPlatform <= 1) {
+		// Check if the stop_position has no referrers at all. If it has no
+		// referrers, then no error should be reported (changed on 11.08.2016 by
+		// darya):
+		if (stopPositionRelationIds.isEmpty()) {
 			return;
 		}
-				
+
+		// Check if route relation lists are identical
+		if (stopPositionRelationIds.equals(platformRelationIds)) {
+			return;
+		}
+		
 		// Throw error message
 		List<OsmPrimitive> primitives = new ArrayList<>(1);
 		primitives.add(relation);
-		TestError e = new TestError(this.test, Severity.WARNING, tr("PT: Stop area relation has several platforms"),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_MANY_PLATFORMS, primitives);
+		TestError e = new TestError(this.test, Severity.WARNING,
+				tr("PT: Route relations of stop position(s) and platform(s) of stop area memebrs diverge"),
+				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_COMPARE_RELATIONS, primitives);
 		errors.add(e);
-		
 	}
 	
Index: applications/editors/josm/plugins/pt_assistant/test/data/stop-area-many-platforms.osm
===================================================================
--- applications/editors/josm/plugins/pt_assistant/test/data/stop-area-many-platforms.osm	(revision 32819)
+++ 	(revision )
@@ -1,57 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<osm version='0.6' upload='true' generator='JOSM'>
-  <node id='-14897' action='modify' visible='true' lat='12.12569675765' lon='-86.28455907163'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='stop_position' />
-  </node>
-  <node id='-14899' action='modify' visible='true' lat='12.12574315765' lon='-86.28459437163'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='platform' />
-  </node>
-  <node id='-14900' action='modify' visible='true' lat='12.12566785765' lon='-86.28424177163' />
-  <node id='-14901' action='modify' visible='true' lat='12.12569085765' lon='-86.28449517163' />
-  <node id='-14902' action='modify' visible='true' lat='12.12586275765' lon='-86.28635997163' />
-  <node id='-14903' action='modify' visible='true' lat='12.12586605765' lon='-86.28641487163' />
-  <node id='-14904' action='modify' visible='true' lat='12.12592805765' lon='-86.28729767163' />
-  <node id='-14906' action='modify' visible='true' lat='12.12598865765' lon='-86.28844557163' />
-  <node id='-14907' action='modify' visible='true' lat='12.12599975765' lon='-86.28875027163'>
-    <tag k='highway' v='traffic_signals' />
-  </node>
-  <node id='-14908' action='modify' visible='true' lat='12.12602745765' lon='-86.29081977163' />
-  <node id='-14909' action='modify' visible='true' lat='12.12603135765' lon='-86.29160537163' />
-  <node id='-14910' action='modify' visible='true' lat='12.12603245765' lon='-86.29184287163'>
-    <tag k='highway' v='traffic_signals' />
-  </node>
-  <node id='-53674' action='modify' visible='true' lat='12.12573870718' lon='-86.28451924009'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='platform' />
-  </node>
-  <way id='-14898' action='modify' visible='true'>
-    <nd ref='-14900' />
-    <nd ref='-14901' />
-    <nd ref='-14897' />
-    <nd ref='-14902' />
-    <nd ref='-14903' />
-    <nd ref='-14904' />
-    <nd ref='-14906' />
-    <nd ref='-14907' />
-    <nd ref='-14908' />
-    <nd ref='-14909' />
-    <nd ref='-14910' />
-    <tag k='highway' v='primary' />
-    <tag k='lanes' v='2' />
-    <tag k='maxspeed' v='30' />
-    <tag k='name' v='Pista de la Resistencia' />
-    <tag k='oneway' v='yes' />
-    <tag k='surface' v='asphalt' />
-  </way>
-  <relation id='-14942' action='modify' visible='true'>
-    <member type='node' ref='-14897' role='stop' />
-    <member type='node' ref='-53674' role='platform' />
-    <member type='node' ref='-14899' role='platform' />
-    <tag k='name' v='Rotonda El Periodista' />
-    <tag k='public_transport' v='stop_area' />
-    <tag k='public_transport:version' v='2' />
-    <tag k='type' v='public_transport' />
-  </relation>
-</osm>
Index: applications/editors/josm/plugins/pt_assistant/test/data/stop-area-many-stops.osm
===================================================================
--- applications/editors/josm/plugins/pt_assistant/test/data/stop-area-many-stops.osm	(revision 32819)
+++ 	(revision )
@@ -1,56 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<osm version='0.6' upload='true' generator='JOSM'>
-  <node id='-14897' action='modify' visible='true' lat='12.12569675765' lon='-86.28455907163'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='stop_position' />
-  </node>
-  <node id='-14899' action='modify' visible='true' lat='12.12574315765' lon='-86.28459437163'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='platform' />
-  </node>
-  <node id='-14900' action='modify' visible='true' lat='12.12566785765' lon='-86.28424177163' />
-  <node id='-14901' action='modify' visible='true' lat='12.12569085765' lon='-86.28449517163'>
-    <tag k='bus' v='yes' />
-    <tag k='public_transport' v='stop_position' />
-  </node>
-  <node id='-14902' action='modify' visible='true' lat='12.12586275765' lon='-86.28635997163' />
-  <node id='-14903' action='modify' visible='true' lat='12.12586605765' lon='-86.28641487163' />
-  <node id='-14904' action='modify' visible='true' lat='12.12592805765' lon='-86.28729767163' />
-  <node id='-14906' action='modify' visible='true' lat='12.12598865765' lon='-86.28844557163' />
-  <node id='-14907' action='modify' visible='true' lat='12.12599975765' lon='-86.28875027163'>
-    <tag k='highway' v='traffic_signals' />
-  </node>
-  <node id='-14908' action='modify' visible='true' lat='12.12602745765' lon='-86.29081977163' />
-  <node id='-14909' action='modify' visible='true' lat='12.12603135765' lon='-86.29160537163' />
-  <node id='-14910' action='modify' visible='true' lat='12.12603245765' lon='-86.29184287163'>
-    <tag k='highway' v='traffic_signals' />
-  </node>
-  <way id='-14898' action='modify' visible='true'>
-    <nd ref='-14900' />
-    <nd ref='-14901' />
-    <nd ref='-14897' />
-    <nd ref='-14902' />
-    <nd ref='-14903' />
-    <nd ref='-14904' />
-    <nd ref='-14906' />
-    <nd ref='-14907' />
-    <nd ref='-14908' />
-    <nd ref='-14909' />
-    <nd ref='-14910' />
-    <tag k='highway' v='primary' />
-    <tag k='lanes' v='2' />
-    <tag k='maxspeed' v='30' />
-    <tag k='name' v='Pista de la Resistencia' />
-    <tag k='oneway' v='yes' />
-    <tag k='surface' v='asphalt' />
-  </way>
-  <relation id='-14942' action='modify' visible='true'>
-    <member type='node' ref='-14897' role='stop' />
-    <member type='node' ref='-14901' role='stop' />
-    <member type='node' ref='-14899' role='platform' />
-    <tag k='name' v='Rotonda El Periodista' />
-    <tag k='public_transport' v='stop_area' />
-    <tag k='public_transport:version' v='2' />
-    <tag k='type' v='public_transport' />
-  </relation>
-</osm>
Index: applications/editors/josm/plugins/pt_assistant/test/data/stop-area-relations.osm
===================================================================
--- applications/editors/josm/plugins/pt_assistant/test/data/stop-area-relations.osm	(revision 32819)
+++ applications/editors/josm/plugins/pt_assistant/test/data/stop-area-relations.osm	(revision 32822)
@@ -1,39 +1,39 @@
 <?xml version='1.0' encoding='UTF-8'?>
 <osm version='0.6' upload='true' generator='JOSM'>
-  <node id='-60958' action='modify' visible='true' lat='12.12569675765' lon='-86.28455907163'>
+  <node id='-55' action='modify' visible='true' lat='12.12569675765' lon='-86.28455907163'>
     <tag k='bus' v='yes' />
     <tag k='public_transport' v='stop_position' />
   </node>
-  <node id='-60960' action='modify' visible='true' lat='12.12574315765' lon='-86.28459437163'>
+  <node id='-57' action='modify' visible='true' lat='12.12574315765' lon='-86.28459437163'>
     <tag k='bus' v='yes' />
     <tag k='public_transport' v='platform' />
   </node>
-  <node id='-60966' action='modify' visible='true' lat='12.12586275765' lon='-86.28635997163' />
-  <node id='-60968' action='modify' visible='true' lat='12.12586605765' lon='-86.28641487163' />
-  <node id='-60970' action='modify' visible='true' lat='12.12592805765' lon='-86.28729767163' />
-  <node id='-60972' action='modify' visible='true' lat='12.12598865765' lon='-86.28844557163' />
-  <node id='-60974' action='modify' visible='true' lat='12.12599975765' lon='-86.28875027163'>
+  <node id='-59' action='modify' visible='true' lat='12.12586275765' lon='-86.28635997163' />
+  <node id='-61' action='modify' visible='true' lat='12.12586605765' lon='-86.28641487163' />
+  <node id='-63' action='modify' visible='true' lat='12.12592805765' lon='-86.28729767163' />
+  <node id='-65' action='modify' visible='true' lat='12.12598865765' lon='-86.28844557163' />
+  <node id='-67' action='modify' visible='true' lat='12.12599975765' lon='-86.28875027163'>
     <tag k='highway' v='traffic_signals' />
   </node>
-  <node id='-60976' action='modify' visible='true' lat='12.12602745765' lon='-86.29081977163' />
-  <node id='-60978' action='modify' visible='true' lat='12.12603135765' lon='-86.29160537163' />
-  <node id='-60980' action='modify' visible='true' lat='12.12603245765' lon='-86.29184287163'>
+  <node id='-69' action='modify' visible='true' lat='12.12602745765' lon='-86.29081977163' />
+  <node id='-71' action='modify' visible='true' lat='12.12603135765' lon='-86.29160537163' />
+  <node id='-73' action='modify' visible='true' lat='12.12603245765' lon='-86.29184287163'>
     <tag k='highway' v='traffic_signals' />
   </node>
-  <node id='-60997' action='modify' visible='true' lat='12.12605336295' lon='-86.29221374917'>
+  <node id='-75' action='modify' visible='true' lat='12.12605336295' lon='-86.29221374917'>
     <tag k='bus' v='yes' />
     <tag k='public_transport' v='stop_position' />
   </node>
-  <node id='-61002' visible='true' lat='12.1261061435' lon='-86.2922353432'>
+  <node id='-77' visible='true' lat='12.1261061435' lon='-86.2922353432'>
     <tag k='bus' v='yes' />
     <tag k='public_transport' v='platform' />
   </node>
-  <way id='-60982' action='modify' visible='true'>
-    <nd ref='-60958' />
-    <nd ref='-60966' />
-    <nd ref='-60968' />
-    <nd ref='-60970' />
-    <nd ref='-60972' />
-    <nd ref='-60974' />
+  <way id='-79' action='modify' visible='true'>
+    <nd ref='-55' />
+    <nd ref='-59' />
+    <nd ref='-61' />
+    <nd ref='-63' />
+    <nd ref='-65' />
+    <nd ref='-67' />
     <tag k='highway' v='primary' />
     <tag k='lanes' v='2' />
@@ -43,10 +43,10 @@
     <tag k='surface' v='asphalt' />
   </way>
-  <way id='-63380' action='modify' visible='true'>
-    <nd ref='-60974' />
-    <nd ref='-60976' />
-    <nd ref='-60978' />
-    <nd ref='-60980' />
-    <nd ref='-60997' />
+  <way id='-81' action='modify' visible='true'>
+    <nd ref='-67' />
+    <nd ref='-69' />
+    <nd ref='-71' />
+    <nd ref='-73' />
+    <nd ref='-75' />
     <tag k='highway' v='primary' />
     <tag k='lanes' v='2' />
@@ -56,7 +56,7 @@
     <tag k='surface' v='asphalt' />
   </way>
-  <relation id='-60984' action='modify' visible='true'>
-    <member type='node' ref='-60958' role='stop' />
-    <member type='node' ref='-60960' role='platform' />
+  <relation id='-83' action='modify' visible='true'>
+    <member type='node' ref='-55' role='stop' />
+    <member type='node' ref='-57' role='platform' />
     <tag k='name' v='Rotonda El Periodista' />
     <tag k='public_transport' v='stop_area' />
@@ -64,9 +64,9 @@
     <tag k='type' v='public_transport' />
   </relation>
-  <relation id='-60986' action='modify' visible='true'>
-    <member type='node' ref='-60958' role='stop' />
-    <member type='node' ref='-61002' role='platform' />
-    <member type='way' ref='-60982' role='' />
-    <member type='way' ref='-63380' role='' />
+  <relation id='-85' action='modify' visible='true'>
+    <member type='node' ref='-55' role='stop' />
+    <member type='way' ref='-79' role='' />
+    <member type='way' ref='-81' role='' />
+    <member type='node' ref='-75' role='stop' />
     <tag k='bus' v='yes' />
     <tag k='from' v='Cuesta el Plomo' />
@@ -78,7 +78,7 @@
     <tag k='type' v='route' />
   </relation>
-  <relation id='-61332' action='modify' visible='true'>
-    <member type='node' ref='-60997' role='stop' />
-    <member type='node' ref='-61002' role='platform' />
+  <relation id='-87' action='modify' visible='true'>
+    <member type='node' ref='-75' role='stop' />
+    <member type='node' ref='-77' role='platform' />
     <tag k='name' v='Mercado Oriental' />
     <tag k='public_transport' v='stop_area' />
Index: applications/editors/josm/plugins/pt_assistant/test/unit/org/openstreetmap/josm/plugins/pt_assistant/validation/StopCheckerTest.java
===================================================================
--- applications/editors/josm/plugins/pt_assistant/test/unit/org/openstreetmap/josm/plugins/pt_assistant/validation/StopCheckerTest.java	(revision 32819)
+++ applications/editors/josm/plugins/pt_assistant/test/unit/org/openstreetmap/josm/plugins/pt_assistant/validation/StopCheckerTest.java	(revision 32822)
@@ -33,5 +33,5 @@
 		Assert.assertEquals(nodeChecker.getErrors().size(), 1);
 		Assert.assertEquals(nodeChecker.getErrors().get(0).getCode(),
-				PTAssistantValidatorTest.ERROR_CODE_NODE_PART_OF_STOP_AREA);
+				PTAssistantValidatorTest.ERROR_CODE_NOT_PART_OF_STOP_AREA);
 	}
 	
@@ -39,5 +39,5 @@
 
 	@Test
-	public void stopPositionComparePlatformRelations() {
+	public void stopAreaRelationsTest() {
 		
 		// Check if stop positions belong the same routes as related platform(s)
@@ -46,18 +46,17 @@
 		DataSet ds = ImportUtils.importOsmFile(file, "testLayer");
 		PTAssistantValidatorTest test = new PTAssistantValidatorTest();
-		Node node = null;
+		Relation stopArea = null;
 		
-		for (Node n : ds.getNodes()) {
-			if (n.hasTag("public_transport", "stop_position")) {
-				node = n;
+		for (Relation r : ds.getRelations()) {
+			if (r.hasTag("public_transport", "stop_area")) {
+				stopArea = r;
 			}
 		}
 		
-		NodeChecker nodeChecker = new NodeChecker(node, test);
-		nodeChecker.performStopPositionComparePlatformRelations();
-		Assert.assertEquals(nodeChecker.getErrors().size(), 1);
-		Assert.assertEquals(nodeChecker.getErrors().get(0).getCode(),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_POSITION_COMPARE_RELATIONS);
-			
+		StopChecker stopChecker = new StopChecker(stopArea, test);
+		stopChecker.performStopAreaRelationsTest();
+		Assert.assertEquals(stopChecker.getErrors().size(), 1);
+		Assert.assertEquals(stopChecker.getErrors().get(0).getCode(),
+				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_COMPARE_RELATIONS);		
 	}
 	
@@ -66,5 +65,5 @@
 	public void stopAreaStopPositionTest() {
 		
-		// Check if stop area relation has one stop position. 
+		// Check if stop area relation has at least one stop position. 
 		
 		File file = new File(AbstractTest.PATH_TO_STOP_AREA_NO_STOPS);
@@ -87,33 +86,9 @@
 	}
 	
-	@Test
-	public void stopAreaMultiStopPositionTest() {
-		
-		// Check if stop area relation has more than one stop position. 
-		
-		File file = new File(AbstractTest.PATH_TO_STOP_AREA_MANY_STOPS);
-		DataSet ds = ImportUtils.importOsmFile(file, "testLayer");
-		PTAssistantValidatorTest test = new PTAssistantValidatorTest();
-		Relation stopArea = null;
-
-		for (Relation r : ds.getRelations()) {
-			if (r.hasTag("public_transport", "stop_area")) {
-				stopArea = r;
-			}
-		}
-
-		StopChecker stopChecker = new StopChecker(stopArea, test);
-		stopChecker.performStopAreaMultiStopPositionTest();
-		Assert.assertEquals(stopChecker.getErrors().size(), 1);
-		Assert.assertEquals(stopChecker.getErrors().get(0).getCode(),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_MANY_STOPS);
-
-	}
-	
 
 	@Test
 	public void stopAreaPlatformTest() {
 		
-		// Check if stop area relation has one platform. 
+		// Check if stop area relation has at least one platform. 
 		
 		File file = new File(AbstractTest.PATH_TO_STOP_AREA_NO_PLATFORMS);
@@ -135,28 +110,4 @@
 
 	}
-	
-	@Test
-	public void stopAreaMultiPlatformTest() {
-		
-		// Check if stop area relation has more than one stop position. 
-		
-		File file = new File(AbstractTest.PATH_TO_STOP_AREA_MANY_PLATFORMS);
-		DataSet ds = ImportUtils.importOsmFile(file, "testLayer");
-		PTAssistantValidatorTest test = new PTAssistantValidatorTest();
-		Relation stopArea = null;
-
-		for (Relation r : ds.getRelations()) {
-			if (r.hasTag("public_transport", "stop_area")) {
-				stopArea = r;
-			}
-		}
-
-		StopChecker stopChecker = new StopChecker(stopArea, test);
-		stopChecker.performStopAreaMultiPlatformTest();
-		Assert.assertEquals(stopChecker.getErrors().size(), 1);
-		Assert.assertEquals(stopChecker.getErrors().get(0).getCode(),
-				PTAssistantValidatorTest.ERROR_CODE_STOP_AREA_MANY_PLATFORMS);
-
-	}
 
 }