Index: applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/BooleanConfigurer.java
===================================================================
--- applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/BooleanConfigurer.java	(revision 32676)
+++ applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/BooleanConfigurer.java	(revision 32912)
@@ -65,4 +65,5 @@
             box.setSelected(booleanValue().booleanValue());
             box.addItemListener(new java.awt.event.ItemListener() {
+                @Override
                 public void itemStateChanged(java.awt.event.ItemEvent e) {
                     setValue(box.isSelected());
Index: applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/DoubleConfigurer.java
===================================================================
--- applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/DoubleConfigurer.java	(revision 32676)
+++ applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/DoubleConfigurer.java	(revision 32912)
@@ -12,5 +12,5 @@
 
     public DoubleConfigurer(String key, String name) {
-        this(key, name, new Double(0));
+        this(key, name, 0d);
     }
 
Index: applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerAction.java
===================================================================
--- applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerAction.java	(revision 32676)
+++ applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerAction.java	(revision 32912)
@@ -58,4 +58,5 @@
     }
 
+    @Override
     public void actionPerformed(ActionEvent e) {
         if (Main.map == null || Main.map.mapView == null || active)
@@ -83,9 +84,5 @@
 
                 // sort files by date (most recent first)
-                Arrays.sort(wmsCache, new Comparator<File>() {
-                    public int compare(File f1, File f2) {
-                        return (int) (f2.lastModified()-f1.lastModified());
-                    }
-                });
+                Arrays.sort(wmsCache, Comparator.comparingLong(File::lastModified));
 
                 // delete aged or oversized, keep newest. Once size/age limit was reached delete all older files
@@ -296,4 +293,5 @@
     }
 
+    @Override
     public void mouseClicked(MouseEvent e) {
         if (active) {
@@ -305,13 +303,17 @@
     }
 
+    @Override
     public void mouseEntered(MouseEvent e) {
     }
 
+    @Override
     public void mouseExited(MouseEvent e) {
     }
 
+    @Override
     public void mousePressed(MouseEvent e) {
     }
 
+    @Override
     public void mouseReleased(MouseEvent e) {
     }
Index: applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java
===================================================================
--- applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java	(revision 32676)
+++ applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java	(revision 32912)
@@ -73,5 +73,7 @@
     }
 
+    @Override
     public void addGui(PreferenceTabbedPane gui) {
+        //CHECKSTYLE.OFF: LineLength
         maxSegsConfig.setToolTipText(tr("Maximum number of segments allowed in each generated way. Default 250."));
         maxNodesConfig.setToolTipText(tr("Maximum number of nodes to generate before bailing out (before simplifying lines). Default 50000."));
@@ -88,4 +90,5 @@
         maxCacheAgeConfig.setToolTipText(tr("Maximum age of each cached file in days. Default is 100"));
         sourceConfig.setToolTipText(tr("Data source text. Default is Landsat."));
+        //CHECKSTYLE.ON: LineLength
 
         /*String description =*/ tr("A plugin to trace water bodies on Landsat imagery.");
@@ -148,4 +151,5 @@
     * Save entered preference values on OK button
     */
+    @Override
     public boolean ok() {
         Main.pref.put(PREF_MAX_SEG, maxSegsConfig.getValueString());
Index: applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/StringEnumConfigurer.java
===================================================================
--- applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/StringEnumConfigurer.java	(revision 32676)
+++ applications/editors/josm/plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/StringEnumConfigurer.java	(revision 32912)
@@ -50,4 +50,5 @@
             setValue(value);
             box.addActionListener(new ActionListener() {
+                @Override
                 public void actionPerformed(ActionEvent e) {
                     noUpdate = true;